// bar.c
// ======================================
//  դν
// ======================================
#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>

#include "graph.h"
#include "segment.h"

#define PAT_FILL100 (7)
#define FILLPAT(i) (i+14)
#define L_ATTR(i,w) ((i)*256 + (w))

// ======================================
//  Ѥδܴؿ
// ======================================

// --------------------------------------
//  minmax֤nʬ䤷iܤʬ֤
// --------------------------------------
static W Split(W min, W max, W i, W n)
{
  W wk;
  
  if (i <= 0) return min;
  if (i >= n) return max;
  wk = max - min;
  wk *= i;
  wk /= n;
  return wk + min;
}


// --------------------------------------
// Ĺ򡤲nʬ䤷mʬĹʬ䤹
// --------------------------------------
static W HSplitRect(RECT frame, W n, W m, RECT *flist)
{
  W i, cnt;
  
  if (n < 2 || m < 1 || n <= m) {
    ERROR(EA_PAR, "HSplitRect");
    return EA_PAR;
  }
  cnt = n / m;
  for (i = 0; i < cnt; ++i) {
    if ((i+1)*m > n) break;
    flist[i].c.top    = frame.c.top;
    flist[i].c.left   = Split(frame.c.left, frame.c.right, i*m, n);
    flist[i].c.bottom = frame.c.bottom;
    flist[i].c.right  = Split(frame.c.left, frame.c.right, (i+1)*m, n);
  }
  return cnt;
}

// --------------------------------------
// Ĺ򡤽Ĥnʬ䤷⤵mʬι⤵Ĺʬ䤹
// --------------------------------------
static W VSplitRect(RECT frame, W n, W m, RECT *flist)
{
  W i, cnt;
  
  if (n < 2 || m < 1 || n <= m) {
    ERROR(EA_PAR, "VSplitRect");
    return EA_PAR;
  }
  cnt = n / m;
  for (i = 0; i < cnt; ++i) {
    if ((i+1)*m > n) break;
    flist[i].c.left   = frame.c.left;
    flist[i].c.top    = Split(frame.c.top, frame.c.bottom, i*m, n);
    flist[i].c.right  = frame.c.right;
    flist[i].c.bottom = Split(frame.c.top, frame.c.bottom, (i+1)*m, n);
  }
  return cnt;
}

// --------------------------------------
// ???
// --------------------------------------
TABLE* GetGraphScale(AXIS* axis, W iCy)
{
  TABLE *hDbl = 0, *hInt = 0;
  DOUBLE wk;
  W n, i;
  W sts;
 
  // ENTRY("GetGraphScale()");
  
  if (axis->scale == 0.0)
    return 0;
  
  // Υ
  n = 0;
  if (axis->min > 0.0) {
    // dMax,dMin ξ
    for (wk = axis->min + axis->scale; wk < axis->max; wk += axis->scale) {
      n++;
    }
  }
  else if (axis->max < 0.0){
    // dMax,dMin ξ */
    for (wk = axis->max+axis->scale; wk > axis->min; wk -= axis->scale) {
      n++;
    }
  }
  else {
    for (wk = axis->scale; wk < axis->max; wk += axis->scale) {
      n++;
    }
    for (wk = (0.0 - axis->scale); wk > axis->min; wk -= axis->scale) {
      n++;
    }
  }
  if (n == 0)
    return 0;
  
  // ɽ֤Ͽ
  if ((hDbl = cre_tbl(1, n, sizeof(DOUBLE))) == NULL) {
    sts = 0;
    goto error;
  }
  
  i = 0;
  if (axis->min > 0.0) {
    // dMax,dMin ξ
    for (wk = axis->min+axis->scale; wk < axis->max; wk += axis->scale, ++i) {
      set_tbl(hDbl, 0, i, &wk);
    }
  }
  else if (axis->max < 0.0){
    // dMax,dMin ξ
    for (wk = axis->max+axis->scale; wk > axis->min; wk -= axis->scale, ++i) {
      set_tbl(hDbl, 0, i, &wk);
    }
  }
  else {
    for (wk = axis->scale; wk < axis->max; wk += axis->scale, ++i) {
      set_tbl(hDbl, 0, i, &wk);
    }
    for (wk = (0.0 - axis->scale); wk > axis->min; wk -= axis->scale, ++i) {
      set_tbl(hDbl, 0, i, &wk);
    }
  }
  
  // ͤɸͤѴ
  if ((hInt = cre_tbl(1, n, sizeof(W))) == NULL) {
    sts = 0;
    goto error;
  }
  if ((sts = d2i_tbl(hInt, hDbl, axis->max, axis->min, iCy, 0)) < 0) {
    goto error;
  }
  
  del_tbl(hDbl, FALSE);
  
  // EXIT("GetGraphScale()");
  
  return hInt;
  
 error:
  if (hDbl != 0) del_tbl(hDbl, FALSE);
  if (hInt != 0) del_tbl(hInt, FALSE);
  return 0;    
}

W GetGraphOrg(DOUBLE dMax, DOUBLE dMin, W iCy)
{
  return dtoi(0.0, dMax, dMin, iCy, 0);
}

// --------------------------------------
// դȤ
// --------------------------------------
TC* GenGraphFrame(TC* seg, W hScale, RECT frame)
{
  W row, column, sts, i, ival;
  PNT start, end;
  RECT gframe;
  
  // ENTRY("GenGraphFrame()");
  
  // 롼׳
  seg = (TC*)GenGroupStart(seg, 0);
  
  // 
  gframe = frame;
  gframe.c.right += 1;
  gframe.c.bottom += 1;
  seg = (TC*)GenRect(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, 0, 0, gframe);
  
  // ʻ
  if (hScale >= 0) {
    if ((sts = get_tbf(hScale, &row, &column)) < 0) {
      ERROR(sts, "GenGraphFrame[1]");
      return seg;
    }
    for(i = 0; i < column; ++i) {
      if ((sts = get_tbl(hScale, 0, i, &ival)) < 0) {
        ERROR(sts, "GenGraphFrame[2]");
        return seg;
      }
      start.x = frame.c.left;
      start.y = frame.c.bottom - ival;
      end.x = frame.c.right;
      end.y = start.y;
      seg = (TC*)GenLine(seg, G_STORE, L_ATTR(LN_DASH,1), PAT_FILL100, start, end);
    }
  }
  seg = (TC*)GenGroupEnd(seg);
  // EXIT("GenGraphFrame()");
  
  return seg;
}

// --------------------------------------
// դμ
// --------------------------------------
TC* GenGraphAxis(TC* seg, W y0, W hScale, RECT frame)
{
  W row, column, sts, i, ival;
  PNT start, end;
  
  // ENTRY("GenGraphAxis()");
  
  // 롼׳
  seg = (TC*)GenGroupStart(seg, 0);
  
  // ʿ
  start.x = frame.c.left;
  start.y = frame.c.bottom - y0;
  end.x = frame.c.right;
  end.y = frame.c.bottom - y0;
  seg = (TC*)GenLine(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, start, end);
  
  // ľ
  start.x = frame.c.left;
  start.y = frame.c.bottom;
  end.x = frame.c.left;
  end.y = frame.c.top;
  seg = (TC*)GenLine(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, start, end);
  
  // 
  if (hScale >= 0) {
    if ((sts = get_tbf(hScale, &row, &column)) < 0) {
      ERROR(sts, "GenGraphAxis[1]");
      return seg;
    }
    for(i = 0; i < column; ++i) {
      start.x = frame.c.left;
      if ((sts = get_tbl(hScale, 0, i, &ival)) < 0) {
        ERROR(sts, "GenGraphAxis[2]");
        return seg;
      }
      start.y = frame.c.bottom - ival;
      end.x = start.x + 4;
      end.y = start.y;
      seg = (TC*)GenLine(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, start, end);
    }
  }
  // 롼׽λ
  seg = (TC*)GenGroupEnd(seg);
  // EXIT("GenGraphAxis()");
  
  return seg;
}

// ======================================
// դν
// ======================================

// --------------------------------------
// պΰʬ䤷
// --------------------------------------
LOCAL RECT split[MAX_LABEL];

// ======================================
// ӷդν
// ======================================

// --------------------------------------
// ɽΥǡ򥰥պѤοͤѴ
// --------------------------------------
LOCAL TABLE* GetBar1Data(TABLE* hTbl, AXIS* axis, W cy)
{
  TABLE* hInt = 0;
  W sts;
  
  // ENTRY("GetBar1Data()");
  
  // ƱΥơ֥
  if ((hInt = cre_ctb(hTbl, sizeof(W))) == 0) {
    sts = -1;
    ERROR(sts, "GetBar1Data[1]");
    goto error;
  }
  // ¿ͤɸ͡ˤѴ
  if ((sts = d2i_tbl(hInt, hTbl, axis->max, axis->min, cy, 0)) < 0) {
    ERROR(sts, "GetBar1Data[2]");
    goto error;
  }
  // EXIT("GetBar1Data()");

  return hInt;
  
 error:
  if (hInt != 0) del_tbl(hInt, FALSE);
  return 0;    
}

// --------------------------------------
// ӷդο޷ǡʬ
// --------------------------------------
TC* GenBar1(TC* seg, W n, W i, W dt, W y0, RECT frame)
{
  RECT bar;
  
  // ENTRY("GenBar1()");
  
  if (dt == y0) {
    // ǡξϥǡʤ
    return seg;
  }

  bar.c.right  = Split(frame.c.left, frame.c.right, i+2, n) + 1;
  bar.c.left   = Split(frame.c.left, frame.c.right, i+1, n);
  if (dt > y0) {
    bar.c.bottom = frame.c.bottom - y0 + 1;
    bar.c.top    = frame.c.bottom - dt;
  }
  else {
    bar.c.top    = frame.c.bottom - y0;
    bar.c.bottom = frame.c.bottom - dt + 1;
  }
  seg = (TC*)GenRect(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, FILLPAT(i), 0, bar);
  
  // EXIT("GenBar1()");
  
  return seg;
}

// --------------------------------------
// ӷդο޷ǡ
// --------------------------------------
TABLE* GenBarGraph1(TC* seg, W nlab, W ndat, TABLE* hTbl, W hScale, AXIS* axis, RECT frame)
{
  W i, j, sts, dt;
  TABLE* hDat = 0;
  W y0;
  
  // ENTRY("GenBarGraph1()");

  // եǡɸͤѴ
  if ((hDat = GetBar1Data(hTbl, axis, rectheight(frame))) == 0) {
    ERROR(sts, "GenBarGraph1[1]");
    goto exit;
  }
  // պΰʬ
  HSplitRect(frame, nlab*(ndat+1)+1, ndat+1, split);
  
  // ޥѥϿ
  seg = (TC*)CreatePattern(seg, ndat);
  
  seg = (TC*)GenGroupStart(seg, 0);
  
  // ȡʻҤκ
  seg = GenGraphFrame(seg, hScale, frame);

  // κ
  y0 = GetGraphOrg(axis->max, axis->min, rectheight(frame));
  seg = GenGraphAxis(seg, y0, hScale, frame);

  for(i=0; i<ndat; ++i) {
    seg = (TC*)GenGroupStart(seg, 0);
    for (j=0; j<nlab; ++j) {
      if ((sts = get_tbl(hDat, j, i, &dt)) < 0) {
        ERROR(sts, "GenBarGraph1[2]");
      }
      seg = GenBar1(seg, ndat+1, i, dt, y0, split[j]);
    }
    seg = (TC*)GenGroupEnd(seg);
  }
  seg = (TC*)GenGroupEnd(seg);
  *seg = TC_NULL;
  
  return hDat;

 exit:
  if (hDat != 0) del_tbl(hDat, FALSE);
  // EXIT("GenBarGraph1()");
  
  return 0;
}

// ======================================
// ѷդν
// ======================================

// --------------------------------------
// ɽΥǡ򥰥պѤοͤѴ
// --------------------------------------
TABLE* GetBar2Data(TABLE* hTbl, AXIS* axis, W cy)
{
  TABLE* hInt = 0;
  DOUBLE min, max, wk;
  DOUBLE* dp;
//  W row, column, ir, ic;
  W ir, ic;
  W n;
  W sts;
  
  // ENTRY("GetBar2Data()");

  // ǡѲû
  for (ir = 0; ir < hTbl->row; ++ir) {
    for (ic = 0; ic < hTbl->column; ++ic) {
      if (ic == 0) {
        if ((sts = get_tbl(hTbl, ir, ic, &wk)) < 0) {
          ERROR(sts, "GetBar2Data[3]");
          goto error;
        }
        if (wk < 0.0) wk = 0.0;
      }
      else {
        dp = (DOUBLE*)get_adr(hTbl, ir, ic);
        if (*dp > 0.0) wk += *dp;
        *dp = wk;
      }
    }
  }
  // ͤɸͤѴ
  if ((hInt = cre_ctb(hTbl, sizeof(W))) == 0) {
    ERROR(sts, "GetBar2Data[5]");
    goto error;
  }
  if ((sts = d2i_tbl(hInt, hTbl, axis->max, axis->min, cy, 0)) < 0) {
    ERROR(sts, "GetBar2Data[6]");
    goto error;
  }
  // EXIT("GetBar2Data()");
  
  return hInt;

 error:
  if (hInt != 0) del_tbl(hInt, FALSE);
  return 0;    
}

// --------------------------------------
// ѷդο޷ǡʬ
// --------------------------------------
TC* GenBar2(TC* seg, W dt1, W dt2, W y0, RECT frame, W f_pat)
{
  RECT bar;
  
  //  ENTRY("GenBar2()");
  
  if (dt1 == dt2) {
    // ǡƱϥǡʤ
    return seg;
  }
  bar.c.right = frame.c.right + 1;
  bar.c.left = Split(frame.c.left, frame.c.right, 1, 3);
  bar.c.bottom = frame.c.bottom - dt1 + 1;
  bar.c.top    = frame.c.bottom - dt2;
  seg = (TC*)GenRect(seg, G_STORE, L_ATTR(LN_SOLID,1), PAT_FILL100, f_pat, 0, bar);

  // EXIT("GenBar2()");
  
  return seg;
}

// --------------------------------------
// ѷդο޷ǡ
// --------------------------------------
TABLE* GenBarGraph2(TC* seg, W nlab, W ndat, TABLE* hTbl, W hScale, AXIS* axis, RECT frame)
{
  W i, j, sts, dt1, dt2;
  TABLE* hDat = 0;
  W y0;

  // ENTRY("GenBarGraph2()");

  // եǡɸͤѴ
  if ((hDat = GetBar2Data(hTbl, axis, rectheight(frame))) == 0) {
    ERROR(sts, "GenBarGraph2[1]");
    goto exit;
  }
  
  // պΰʬ
  HSplitRect(frame, nlab*3 + 1, 3, split);

  // ޥѥϿ
  seg = (TC*)CreatePattern(seg, ndat);

  seg = (TC*)GenGroupStart(seg, 0);

  // ȡʻҤκ
  seg = GenGraphFrame(seg, hScale, frame);

  // κ
  y0 = GetGraphOrg(axis->max, axis->min, rectheight(frame));
  // seg = (TC*)GenGraphAxis(seg, hScale, frame);
  seg = (TC*)GenGraphAxis(seg, y0, hScale, frame);

  for(i = 0; i < nlab; ++i) {
    seg = (TC*)GenGroupStart(seg, 0);
    dt1 = 0;
    for (j=0; j<ndat; ++j) {
      if ((sts = get_tbl(hDat, i, j, &dt2)) < 0) {
        ERROR(sts, "GenBarGraph2[2]");
      }
      seg = GenBar2(seg, dt1, dt2, y0, split[i], FILLPAT(j));
      dt1 = dt2;
    }
    seg = (TC*)GenGroupEnd(seg);
  }
  seg = (TC*)GenGroupEnd(seg);
  *seg = TC_NULL;
  
  return hDat;

 exit:
  if (hDat != 0) del_tbl(hDat, FALSE);
  // EXIT("GenBarGraph2()");
  
  return 0;
}

