#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <stdio.h>

#include	"grapherr.h"

char *syserr[] = {
  "E_OK    ", //   0: Normal end
  "E_ADR   ", // - 1: Illegal address in core
  "E_PAR   ", // - 2: Parameter is out of range
  "E_NOSPT ", // - 3: Logical block is out of range
  "E_NOSPC ", // - 4: No more system space
  "E_ID    ", // - 5: ID value is out of range
  "E_EXS   ", // - 6: File is already created
  "E_NOEXS ", // - 7: File path doesn't exist
  "E_NOMEM ", // - 8: Lack of memory
  "E_CTX   ", // - 9: Context error
  "E_SYS   ", // -10: System error
  "E_UNF   ", // -11: Undefined system call
  "E_SZOVR ", // -12: Argument size is too big
  "E_MPTR  ", // -13: Memory blck ptr not correct
  "E_AKEY  ", // -14: Illegal access key
  "E_MPURG ", // -15: Memory block is purged
  "E_MRELOC", // -16: Relocated shared" // -memory" // -block
  "E_PPRI  ", // -17: Priority is out of range
  "E_NOPRC ", // -18: No process
  "E_SELF  ", // -19: Specify own process
  "E_LEVEL ", // -20: Specify high userlevel prces
  "E_MINTR ", // -21: Waiting interruption by Msghdr
  "E_DLT   ", // -22: When semaphore waiting,deltd
  "E_SEM   ", // -23:
  "E_NONE  ", // -24: No specified message
  "E_INIT  ", // -25: Aborted init" // -handler
  "E_FNAME ", // -26: Pathname include bad letter
  "E_FD    ", // -27: File descriptor is not opened
  "E_ACCES ", // -28: No access right of file
  "E_PERM  ", // -29: Non.Delete" // -file
  "E_RONLY ", // -30: Read only file
  "E_PWD   ", // -31: Passward illegal
  "E_ENDR  ", // -32: is END" // -RECORD
  "E_REC   ", // -33: Record.type illegal
  "E_NOLNK ", // -34: Not Link.File
  "E_LOCK  ", // -35: Locked by others
  "E_LIMIT ", // -36: Too many link
  "E_XFS   ", // -37:
  "E_NOFS  ", // -38: Not Connect F.System
  "E_NODSK ", // -39: No Disk space
  "E_TRON  ", // -40: Not TRON device file
  "E_DD    ", // -41: Not exist d.descript
  "E_DEV   ", // -42: Device type incorrect
  "E_BUSY  ", // -43: Device/file is busy
  "E_NODEV ", // -44: cannot acces to Device
  "E_ERDEV ", // -45: Occurred Device.Error
  "E_NOMDA ", // -46: No Media
  "E_IO    ", // -47: I/O error occured
  "E_?48   ", // -48:
  "E_?49   ", // -49:
  "E_?50   ", // -50:
  "E_?51   ", // -51:
  "E_?52   ", // -52:
  "E_?53   ", // -53:
  "E_?54   ", // -54:
  "E_?55   ", // -55:
  "E_?56   ", // -56:
  "E_?57   ", // -57:
  "E_?58   ", // -58:
  "E_?59   ", // -59:
  "E_?60   ", // -60:
  "E_?61   ", // -61:
  "E_NODISK", // -62: Disk None
  "E_NOWAIT"  // -63: no wait of Parebt.Proc's
};

char *hmierr[] = {
  "EX_ADR  ", // -257: Invalid address
  "EX_AKEY ", // -258: Invalid access key
  "EX_DATA ", // -259: Not data file
  "EX_CKEY ", // -260: "ichi ji keshi"key error
  "EX_DFMT ", // -261: Invalid data format
  "EX_DNUM ", // -262: Invalid data number
  "EX_DRAG ", // -263: Can not drag
  "EX_EXS  ", // -264: application already exist
  "EX_FD   ", // -265: Invalid data file id
  "EX_FONT ", // -266: Invalid font file format
  "EX_FTD  ", // -267: Invalid font descripter
  "EX_FTFMT", // -268: Invalid font data format
  "EX_FTID ", // -269: Invalid font ID
  "EX_?270 ", // -270:
  "EX_?271 ", // -271:
  "EX_KEY  ", // -272: Injustical keycode included
  "EX_LIMIT", // -273: Limit size over
  "EX_MID  ", // -274: Invalid menu id
  "EX_?275 ", // -275:
  "EX_NAK  ", // -276: Not Acknowledge
  "EX_NOSPC", // -277: No more memory
  "EX_NOEXS", // -278: Application do not exist
  "EX_PAR  ", // -279: Invalid parameter
  "EX_PID  ", // -280: Not exist parts_id
  "EX_PNID ", // -281: Not exist panel_id
  "EX_SAVE ", // -282: No space for image save
  "EX_SDATA", // -283: Not exist system data file
  "EX_TID  ", // -284: Tip ID is not exist
  "EX_NOSPT", // -285: Tip not support
  "EX_TRAY ", // -286: Tray not opened
  "EX_WID  ", // -287: Not exist window_id
  "EX_WND  ", // -288: Window attr not correct
  "EX_WPRC ", // -289: Window process not correct
  "EX_VID  ", // -290: Virtual object ID correct
  "EX_VOBJ ", // -291: Not exist virtual object
  "EX_?292 ", // -292:
  "EX_?293 ", // -293:
  "EX_?294 ", // -294:
  "EX_?295 ", // -295:
  "EX_?296 ", // -296:
  "EX_?297 ", // -297:
  "EX_?298 ", // -298:
  "EX_?299 ", // -299:
  "EX_SPOOL", // -300: Spooler is not exist
  "EX_PROC ", // -301: Process is not exist
  "EX_SPOBJ", // -302: Output object name is not exist
  "EX_SPID ", // -303: Spooler ID is not exist
  "EX_FILE "  // -304: File is not exist
};

char *aplerr[] = {
  "EA_PAR  ", // -513: ѥ᥿顼
  "EA_HTBL ", // -514: ơ֥ϥɥ륨顼
  "EA_HLST ", // -515: ꥹȥϥɥ륨顼
  "EA_LIMIT", // -516: ;¤ۤ
  "EA_UNDEF", // -517: ˼
  "EA_NOSPT", // -518: ̤
  "EA_AREA ", // -519: ϰϺɸΰ۾
  "EA_ERROR", // -520: 饤֥Υ顼
  "EA_MASK ", // -521: ޥ̤
  
  "EA_10   ", // -522:
  "EA_11   ", // -523:
  "EA_12   ", // -524:
  "EA_13   ", // -525:
  "EA_14   ", // -526:
  "EA_15   ", // -527:
  "EA_16   "  // -528:
};

char sys_other[] = "E_??????";
char hmi_other[] = "EX_?????";
char apl_other[] = "EA_?????";

static char *errcd(W err)
{
  if (err < EA_LAST)
    return apl_other;
  if (err < -512)
    return aplerr[0-(err+513)];
  if (err < -304)
    return hmi_other;
  else if (err < -256)
    return hmierr[0-(err+257)];
  else if (err < -63)
    return sys_other;
  else
    return syserr[0-(err>0 ? 0 : err)];
}

void debug_error(W err, B* memo)
{
  printf("*** ERROR: %d[%s] <%s>) ***\n", err, errcd(err), memo);
}

void debug_dump(W* data, W size, W* memo)
{
  W i;

  printf("*** DUMP:(%s)***", memo);
  for(i = 0; i<size; ++i) {
    if (i%8 == 0) {
      printf("\n  %04x:", i*2);
    }
    printf(" %04x", *data++);
  }
  printf("\n");
}

void debug_checkpoint(W* memo)
{
  printf("*** Check-Point: <%s> ***\n", memo);
}

void debug_entry(W* memo)
{
  printf("*** Entry-Point: <%s> ***\n", memo);
}

void debug_exit(W* memo)
{
  printf("*** ReturnPoint: <%s> ***\n", memo);
}

void snap_dbl(double dval, W* memo)
{
  printf("--- snap(DBL): <%s>=%f \n", memo, dval);
}

void snap_int(W ival, W* memo)
{
  printf("--- snap(INT): <%s>=%04x \n", memo, ival);
}

void snap_lng(W lval, W* memo)
{
  printf("--- snap(LNG): <%s>=%08lx \n", memo, lval);
}

