//
//    disp.c        ץץࡧɽ
//

#include <basic.h>
#include <bstdio.h>
#include <btron/btron.h>
#include <btron/hmi.h>

#include "graph.h"
#include "segment.h"
#include "common.h"
#include "debug.h"

// ɥطʥѥ
static PAT windpat = {0, 16, 16, 0x10ffffff, 0x10000000, FILL100};
//static PAT windpat = {0, 16, 16, 0, 0, FILL100};

// С
typedef struct {
  W clo, chi, lo, hi;
} SCRL_BAR;

static SCRL_BAR hbar = {0,0,0,0}; // С
static SCRL_BAR vbar = {0,0,0,0}; // С

// ɽ RECTLIST
static RLIST view_rl[4] = {
  &view_rl[1], {0,0,0,0},
  &view_rl[2], {0,0,0,0},
  &view_rl[3], {0,0,0,0},
  NULL,        {0,0,0,0}};

// Сɽι
void disp_sbar()
{
  W lo, hi;
  
  if (window[0].wid <= 0) return; // ɥϳƤʤ

  // С
  //   hi  (ü)  : frect.c.top
  //   chi ()    : vrect.c.top
  //   clo ()    : vrect.c.bottom
  //   lo  (ü)  : frect.c.bottom
  hi = frect.c.bottom;
  if (hi < vrect.c.bottom) hi = vrect.c.bottom;
  
  // ͤѹСꤹ
  if (vbar.clo != vrect.c.top || vbar.chi != vrect.c.bottom ||
      vbar.lo  != frect.c.top || vbar.hi != hi) {
    vbar.clo = vrect.c.top;
    vbar.chi = vrect.c.bottom;
    vbar.lo  = frect.c.top;
    vbar.hi  = hi;
    cset_val(window[0].pid[0], 4, (W*)&vbar);
  }
  
  // С:
  //   hi  (ü)  : frect.c.left
  //   chi ()    : vrect.c.left
  //   clo ()    : vrect.c.right
  //   lo  (ü)  : frect.c.right
  lo = frect.c.right;
  if (lo < vrect.c.right ) lo = vrect.c.right;
  
  // ͤѹСꤹ
  if (hbar.clo != vrect.c.right || hbar.chi != vrect.c.left ||
      hbar.lo  != lo  || hbar.hi != frect.c.left ) {
    hbar.clo = vrect.c.right;
    hbar.chi = vrect.c.left;
    hbar.lo  = lo;
    hbar.hi  = frect.c.left;
    cset_val(window[0].pid[1], 4, (W*)&hbar);
  }
}

// ɥɽ
void view(RECT r)
{
  W sts;
  //B* s;
  TC* s;
  TC tc;

  // ENTRY("view()");
  
  setpointer(PS_BUSY, NULL);
  
  // ɽΰΤߤ򥯥åΰȤ
  gset_vis(mygid, r);

  // ޤطʤطʿɤĤ֤
  gfil_rec(mygid, r, &windpat, 0, G_STORE);
  
  // ɽΰˤäƤ륻Ȥ򲼤褹
  for (s = figdat; (tc = *s) != TC_NULL; s = NextSegment(s)) {
    if ((sts = Draw(mygid, r, s)) < 0) {
      ERROR(sts, "view[1]");
    }
  }
  // åΰ򸵤᤹
  gset_vis(mygid, vrect);
  
  setpointer(PS_SELECT, NULL);
  
  // EXIT("view()");
}

// ɽ
static void redisplay()
{
  W nr;
  RECT r;

  do {
    // ɽɬפΰФ
    nr = wsta_dsp(mywid, &r, view_rl);
    if (nr == 0) break;    // ɽΰʤ
    
    // ɽɬפΰκɽԤ
    if (nr > 4) {
      view(r);
    }
    else {
      while (--nr >= 0) { 
        view(view_rl[nr].rcomp);
      }
    }
  } while (wend_dsp (mywid) > 0);
}

// ɽΥ
static void scrl_disp (W dh, W dv)
{
  W sts;

  if (dh || dv) {
    // ΰƤ򥹥뤷ɽɬפΰꤹ
    sts = wscr_wnd (mywid, NULL, dh, dv, W_SCRL|W_RDSET);
    if (sts >= 0) {
      // frame ΰ򿷤ΰ(vrect) Ȥ
      gget_fra (mygid, &vrect);
      gset_vis (mygid, vrect);
      
      // ɽ
      if (sts & W_RDSET) {
        redisplay();
      }
      else  {
        view(vrect);    /* ΰκɽ */
      }
    }
  }
}

// 롦٥Ƚ
void scrl_fn(W ix, W sts, W diff) // *** WORD -> Wؤѹ ***
     // sts =    xxx..xxxxCCTTDD
     //   CC = 0: 1: 2: 
     //   TT = 0: SMOOTH1:AREA2: JUMP
     //   DD = 0: UP1: DOWN2:LEFT3:RIGHT
{
  PNT p;
  
  // ̤׻
  // ࡼñ̤ ɸʸ(CHSSTD) Ȥ
  p = chk_scroll(sts, diff, CHSSTD, vrect, frect);

  // 뤹ɬפϥ뤹
  if (p.x || p.y) {
    scrl_disp (p.x, p.y);
    disp_sbar(); // Сɽι
  }
}

// ɽ٥Ƚ
void disp_fn (W ix, W mode, RECT* new)
     // mode =    -1: ɽ׵
     //     0 : ɽ׵    (׺ɽ)
     //     1 : ư    (/ݺɽ)
     //     2 : ѹ
     //     3 : ѹ    (׺ɽ)
     //     4 : ̾⡼
     //     5 : ̥⡼    (׺ɽ)
     //     6 : ̾⡼    (׺ɽ)
     //     7 : ѥͥ    (׺ɽ)
     //     8 : ѹ
     //     9 : ѹ    (׺ɽ)
{
  if (mode < 0){ // ɽ׵
    view(vrect);
  }
  else {
    // ΰѹäϡΰꤹ
    if (mode >= 2 && mode != 7) {
      vrect = *new; //  vrect
      gset_vis(mygid, vrect);    //  vrect 
    }
    // ɽԤ
    redisplay();
    
    // ΰѹäϡС򹹿
    if (mode >= 2 && mode != 7) {
      // ¦λΰ褬ˤʤϡ
      // 뤷ƺΰ褬ˤʤʤ褦ˤ
      if (vrect.c.left < 0 || vrect.c.top < 0)
        scrl_disp (vrect.c.left, vrect.c.top);
      // Сɽι
      disp_sbar();
    }
  }
}

