// fread.c
// =========================================
// ե
// =========================================
#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>

#include "segment.h"

#define BUFSIZ 0x1000
#define OFFSETMASK 0xfffff000

// եΥץ⡼
static TC omode[2] = {0x2372, 0x0000}; // L""

// ʲϤøʥ饤֥μ
// wb_fdopen, wb_fopen, b_fseek, b_fclose, b_fprst, b_fread

FILE* wb_fopen(TC* fpath, TC* omode)
{
  FILE *fp = 0;

  fp = (FILE*)malloc(sizeof(FILE));
  if (fp == 0) {
    return 0; // failed to malloc
  }
  if (tc_strcmp(omode, (TC[]){0x2372, 0x0000}) != 0) { // L""
    return 0; // not opened for read
  }
  fp->openmode = F_READ;
  fp->error = get_lnk(fpath, &(fp->link), F_NORM);
  if (fp->error < 0) {
    goto exit;
  }
  fp->fd = opn_fil(&(fp->link), fp->openmode, NULL);
  if (fp->fd < 0) {
    goto exit;
  }
  fp->buff = 0;
  fp->first = 1; // true
  return fp;

 exit:
  free(fp);
  return 0;
}

FILE* wb_fdopen(W fd, TC* omode)
{
  FILE *fp = 0;

  fp = (FILE*)malloc(sizeof(FILE));
  if (fp == 0) {
    return 0; // failed to malloc
  }
  if (tc_strcmp(omode, (TC[]){0x2372, 0x0000}) != 0) { // L""
    return 0; // not opened for read
  }
  fp->openmode = F_READ;
  fp->fd = fd;
  fp->buff = 0;
  fp->first = 1; // true
  return fp;
}

W ffndrec(FILE* fp, UW typemask)
{
  W smode = F_NFWD;
  if (fp->first) {
    smode = F_TOPEND;
    fp->first = 0;
  }
  fp->rectype = fp->error = fnd_rec(fp->fd, smode, typemask, 0, 0);
  if (fp->error >= 0) {
    fp->error = rea_rec(fp->fd, 0, NULL, 0, &(fp->recsize), &(fp->subtype));    }
  return fp->error;
}

static int read_to_buffer(FILE *fp)
{
  if (fp->buff == 0) {
    fp->offset = 0;
    fp->buff = (B*)malloc(fp->recsize);
    if (fp->buff == 0) {
      return -1;
    }
    fp->error = rea_rec(fp->fd, 0, fp->buff, fp->recsize, NULL, NULL);
    if (fp->error < 0) {
      free(fp->buff);
      return -1;
    }
  }
  return 0;
}

// ɤ߹Хȿ֤
W fread(B* buf, W len, FILE* fp)
{
  int actual_len = len;

  if (read_to_buffer(fp) < 0) {
    return 0;
  }
  if (actual_len > (fp->recsize - fp->offset)) {
    actual_len = fp->recsize - fp->offset;
  }
  memcpy(buf, &(fp->buff[fp->offset]), actual_len);
  fp->offset += actual_len;
  return actual_len;
}

W b_fseek(FILE* fp, W len, W mode)
{
  int actual_len = len;

  if (mode != 1) return -1; // error

  if (read_to_buffer(fp) < 0) {
    return 0;
  }
  if (actual_len > (fp->recsize - fp->offset)) {
    actual_len = fp->recsize - fp->offset;
  }
  fp->offset += actual_len;
  return actual_len;
}

void b_fclose(FILE* fp)
{
  cls_fil(fp->fd);
  if (fp->buff != 0) {
    free(fp->buff);
  }
  free(fp);
}

W b_fileno(FILE* fp)
{
  return fp->fd;
}

extern TC fgetw(FILE* fp);
extern W file_gets(FILE* fp, TC* str, UW len);
extern W CreateAreaNameList(W vid);
extern TC GetCell(FILE* fp, TC* fsn, TC* cell);

