// fread.c
// ==========================================
// ե
// ==========================================
#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <tstring.h>

#include "graph.h"
#include "segment.h"

// եΥץ⡼
static TC omode[2] = {0x2372, 0x0000}; // L""

TC fgetw(FILE* fp)
{
  TC buf;

  if (fread(&buf, 2, fp) == 0) {
    return EOF;
  }
  return buf;
}

// WORD -> TC
TC fgetseg(FILE* fp, TC** buf)
{
  TC tc;
  W type;//, hMem;
  UW wLen;
  W lLen;
  SEGHEAD *seg;

  if ((tc = fgetw(fp)) == EOF) {
    *buf = (TC*)malloc(sizeof(TC));
    *buf[0] = tc;
    return SEG_EOF;
  }
  if ((type = SegmentType(tc)) != SEG_ESC) {
    *buf = (TC*)malloc(sizeof(TC));
    *buf[0] = tc;
    return type;
  }
  wLen = fgetw(fp);
  if (wLen == 0xffff) {
    fread((B*)&lLen, sizeof(lLen), fp);
    seg = malloc(lLen+sizeof(LTADSEG));
    seg->l.id = tc;
    seg->l.len = 0xffff;
    seg->l.llen = lLen;
    fread(((B*)seg)+sizeof(LTADSEG), lLen, fp);
  }
  else {
    lLen = wLen;
    seg = malloc(lLen+sizeof(TADSEG));
    seg->s.id = tc;
    seg->s.len = wLen;
    fread(((B*)seg)+sizeof(TADSEG), lLen, fp);
  }
  buf = seg;
  return SEG_ESC;
}

// =================================================
// ϰϺɸʣԣ쥳ɡ
// =================================================
// ϰϺɸβ
/*
   ϰϺɸΥեޥåȡ

   Σ򣱡㣱򣲡㣲

     0x2161       0x214e       0x2124
     0x2127       0x214f
*/

// ꤵ줿ʸϰϺɸʪɤ򸡺
BOOL IsArea(TC* str)
{
  // ƬȡΡɰʳǤХ顼
  if ( *str++ != 0x214e) {
    return FALSE;
  }
  // ԡʣ򣱡ˤФ
  tc_strtol(str, &str, 0);
  
  // ڤ꤬ȡɰʳǤХ顼
  if ( *str++ != 0x2124) {
    return FALSE;
  }
  // ʣ㣱ˤФ
  tc_strtol(str, &str, 0);
  
  // ڤ꤬ȡɰʳǤХ顼
  if ( *str++ != 0x2127) {
    return FALSE;
  }
  // ԡʣ򣲡ˤФ
  tc_strtol(str, &str, 0);
  
  // ڤ꤬ȡɰʳǤХ顼
  if ( *str++ != 0x2124) {
    return FALSE;
  }
  // ʣ㣲ˤФ
  tc_strtol(str, &str, 0);
  
  // Ǹ夬ȡϡɰʳǤХ顼
  if ( *str++ != 0x214f) {
    return FALSE;
  }
  return TRUE;
}

// ꤵ줿ʸϰ̾Ԥɤ򸡺
BOOL IsAreaLine(TC* str)
{
  // CHECKPOINT("IsAreaLine()");

  // ԣ¤򸡺
  if ((str = (TC*)tc_strchr(str, 0x0009)) == NULL) {
    return FALSE;
  }
  return IsArea(str+1);
}

W GetAreaVal(TC* str, AREA* area)
{
  UW r1, c1, r2, c2;
  TC num[8];
  W i;
  TC tc;

  //  ENTRY("GetAreaVal()");

  ++str; // ȡΡɤФ
  r1 = tc_strtol(str, &str, 0);
  if (r1 == 0 || r1 > 8191) return EA_AREA;

  ++str; // ȡɤФ
  c1 = tc_strtol(str, &str, 0);
  if (c1 == 0 || c1 > 255) return EA_AREA;
  
  ++str; // ȡɤФ
  r2 = tc_strtol(str, &str, 0);
  if (r2 == 0 || r2 > 8191) return EA_AREA;
  
  ++str; // ȡɤФ
  c2 = tc_strtol(str, &str, 0);
  if (c2 == 0 || c2 > 255) return EA_AREA;

  area->start.column = c1 < c2 ? c1 : c2;
  area->start.row = r1 < r2 ? r1 : r2;
  area->end.column = c1 > c2 ? c1 : c2;
  area->end.row = r1 > r2 ? r1 : r2;

  // EXIT("GetAreaVal()");

  return 0;
}

// ϰ̾ꥹȤϰ̾򸡺ϰϺɸʸֵѤ
W SearchAreaName(W hLst, TC* name, TC* area)
{
  W sts;
  TC* line;

  // ENTRY("SearchAreaName()");
  // DUMP(name, 32, "check");

  *area = TC_NULL;

  if ((sts = ser_lst(hLst, name, &line)) < 0) {
    ERROR(sts, "SearchAreaName[1]");
    return sts;
  }
  // ԣ¤򸡺
  if ((line = (TC*)tc_strchr(line, 0x0009)) == NULL) {
    sts = EA_HLST;
    ERROR(sts, "SearchAreaName[2]");
    return sts;
  }
  tc_strcpy(area, line+1);

  // EXIT("SearchAreaName()");

  return 0;
}

// եθߥ쥳ɤ顤ʸĤ뤫ХåեޤǤ
// ǡɤ߹
W file_gets(FILE* fp, TC* str, UW len)
{
  W i;
  TC tc;

  for (i = 0; i < len; i++){
    str[i] = TC_NULL;
  }

  for (i = 0; i < len-1; ) {
    tc = fgetw(fp);
    if (tc == EOF) {
      break;
    }
    else if (tc == TC_NL || tc == TC_CR) {
      ++i;
      break;
    }
    else if (SegmentType(tc) == SEG_ESC) {
      UW w0, w1, w2;
      W seglen;

      if ((w0 = fgetw(fp)) == 0xffff) {
        w2 = fgetw(fp);
        w1 = fgetw(fp);
        seglen = (w1 << 16) + w2;
      }
      else {
        seglen = w0;
      }
      b_fseek(fp, seglen, 1);
    }
    else {
      *str++ = tc;
      ++i;
    }
  }
  *str = TC_NULL;
  return i;
}

// ԣ쥳ɤϰ̾ǡ򸡺ϰ̾ΥꥹȤ
LIST* CreateAreaNameList(W vid)
{
  W sts;
  W fd;
  FILE* fp = NULL;
  TC str[128];
  LIST* hLst = 0;

  // ENTRY("CreateAreaNameList()");

  // ꥹȤκ
  if ((hLst = cre_lst()) == NULL) {
    ERROR(0, "CreateAreaNameList[1]");
    return 0;
  }
  // ե򥪡ץ󤷡ԣ쥳ɤ򸡺
  if ((fd = oopn_obj(vid, NULL, F_READ, NULL)) < 0) {
    ERROR(fd, "CreateAreaNameList[2]");
    goto exit;
  }
  if ((fp = (FILE*)wb_fdopen(fd, omode)) == NULL) {
    sts = EA_ERROR;
    ERROR(sts, "CreateAreaNameList[3]");
    goto exit;
  }
  if ((sts = ffndrec(fp, RM_TADSUB)) < 0) {
    ERROR(sts, "CreateAreaNameList[4]");
    goto exit;
  }
  // ϰ̾ǡθꥹȤι
  while ((sts = file_gets(fp, str, 128)) > 0) {
    if (IsAreaLine(str)) {
      if((sts = ins_lsti(hLst, -1, 0, (tc_strlen(str)+1)*2, str)) < 0) {
        ERROR(sts, "CreateAreaNameList[5]");
        goto exit;
      }
    }
  }
  b_fclose(fp);

  // EXIT("CreateAreaNameList()");

  return hLst;

 exit:
  if (fp != NULL)  b_fclose(fp);
  if (hLst != NULL)   del_lst(hLst);
  return 0;
}

W GetArea(W vid, TC* str, AREA* area)
{
  W sts;
  TC ts[48];
  TC* pts = str;
  LIST* hLst;

  //ENTRY("GetArea()");

  area->start.column = 0;
  area->start.row = 0;
  area->end.column = 0;
  area->end.row = 0;

  if (!IsArea(pts)) { // ʸå
    if ((hLst = CreateAreaNameList(vid)) == 0) {
      dostdpnl(ER_AREANAME, NULL);
      sts = -1;
      goto exit;
    }
    if ((sts = SearchAreaName(hLst, pts, ts)) < 0) {
      ERROR(sts, "GetArea[2]");
      dostdpnl(ER_AREANAME, NULL);
      goto exit;
    }
    del_lst(hLst);
    hLst = 0;
    pts = ts;
  }
  if ((sts = GetAreaVal(pts, area)) < 0) {
    ERROR(sts, "GetArea[3]");
    dostdpnl(ER_AREARECT, NULL);
    goto exit;
  }

  // EXIT("GetArea()");

  return 0;

 exit:
  if (hLst != 0) del_lst(hLst);
  return sts;
}

// =================================================
// ǡʣԣļ쥳ɡ
// =================================================
W GetCell(FILE* fp, TC* fsn, TC* cell)
{
  W len;
  TC tc;

  // ENTRY("GetCell()");

  *fsn = TC_NULL;
  *cell = TC_NULL;

  for (;;) {
    tc = fgetw(fp);
    if (tc == TC_NL || tc == TC_CR || tc == TC_TAB || tc == EOF) {
      break;
    }
    else if (SegmentType(tc) == SEG_ESC) {
      len = fgetw(fp);
      if ((tc&0x00ff) == TS_DFUSEN) {
        *fsn++ = tc;
        *fsn++ = len;
        fread((B*)fsn, len, fp);
      }
      else {
        b_fseek(fp, len, 1);
      }
    }
    else {
      *cell++ = tc;
    }
  }
  *cell = TC_NULL;

  //  EXIT("GetCell()");

  return tc;
}

// ԣļ쥳ɤϰΥǡФ
TABLE* ReadData(W vid, AREA* area, BOOL swap)
{
  W sts, dlm;
  W fd;
  FILE* fp = NULL;
  TABLE *tbl = 0;
  //W hTbl = -1;
  TC* ts = NULL;
  TC cell[512];
  W len;
//  W fsn[128]; // 
  TC fsn[128];
  UW ir, ic, row, column;

  // ENTRY("ReadData()");

  // ơ֥κ
  if (swap) {
    column = area->end.row - area->start.row + 1;
    row = area->end.column - area->start.column + 1;
  }
  else {
    row = area->end.row - area->start.row + 1;
    column = area->end.column - area->start.column + 1;
  }
  if ((tbl = cre_tbl(row, column, sizeof(TC*))) == 0) {
    ERROR(sts, "ReadData[1]");
    goto exit;
  }
  // ե򥪡ץ󤷡ԣļ쥳ɤ򸡺
  if ((fd = sts = oopn_obj(vid, NULL, F_READ, NULL)) < 0) {
    ERROR(sts, "ReadData[2]");
    goto exit;
  }
  if ((fp = (FILE*)wb_fdopen(fd, omode)) == NULL) {
    sts = EA_ERROR;
    ERROR(sts, "ReadData[3]");
    goto exit;
  }
  if ((sts = ffndrec(fp, RM_TADDATA)) < 0) {
    ERROR(sts, "ReadData[4]");
    goto exit;
  }
  
  // ϰΥǡμФơ֥Ͽ
  ir = 1; ic = 1;
  while (ir <= area->end.row) {
    dlm = GetCell(fp, fsn, cell);
    
    if (fsn[0] != 0) {
      // 䵤ֹֹФ
      checkcalcfusen(fsn, &ir, &ic);
    }
    len = tc_strlen(cell);

    if (ir >= area->start.row    && ir <= area->end.row    &&
        ic >= area->start.column && ic <= area->end.column &&
        len != 0) {
      if (swap) {
        column = ir - area->start.row;
        row = ic - area->start.column;
      }
      else {
        row = ir - area->start.row;
        column = ic - area->start.column;
      }
      len += 1;
      len *= sizeof(TC);
      if ((sts = dup_mem(cell, len, &ts)) < 0) {
        ERROR(sts, "ReadData[5]");
        goto exit;
      }
      if ((sts = set_tbl(tbl, row, column, &ts)) < 0) {
        ERROR(sts, "ReadData[6]");
        goto exit;
      }
      ts = NULL;
    }
    if (dlm == EOF) {
      break;
    }
    else if (dlm == TC_TAB) {
      ic++;
    }
    else /* if (dlm == TC_CR || dlm == TC_NL) */ {
      ir++, ic = 1;
    }
  }
  b_fclose(fp);
  // EXIT("ReadData()");

  return tbl;

 exit:
  if (ts != NULL) free(ts);
  if (fp != NULL) b_fclose(fp);
  if (tbl != 0)  del_tbl(tbl, TRUE);
  return 0;
}

