// gen_fig.c
#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <bstring.h>

#define _GEN_FIG
#include "segment.h"

// -----------------------------------------------------

// =========================================
// ̴ؿ
// =========================================
void AdjustRect(RECT* rect)
{
  RECT wk;

  wk = *rect;
  rect->c.left   = wk.c.left < wk.c.right  ? wk.c.left : wk.c.right;
  rect->c.right  = wk.c.left > wk.c.right  ? wk.c.left : wk.c.right;
  rect->c.top    = wk.c.top  < wk.c.bottom ? wk.c.top  : wk.c.bottom;
  rect->c.bottom = wk.c.top  > wk.c.bottom ? wk.c.top  : wk.c.bottom;
}

// =========================================
// ޷ǥ
// =========================================
// --------------
// Ĺ
// --------------
FSEGMENT* GenRect(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW angle, RECT frame)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_RECT);
  
  seg->fig.rect.mode = mode;
  seg->fig.rect.subid = 0;
  seg->fig.rect.l_atr = l_atr;
  seg->fig.rect.l_pat = l_pat;
  seg->fig.rect.f_pat = f_pat;
  seg->fig.rect.angle = angle;
  seg->fig.rect.frame = frame;
  AdjustRect(&seg->fig.rect.frame);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ѴĹ
// ------------------
FSEGMENT* GenRrect(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW angle, UW rh, UW rv, RECT frame)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_RRECT);
  
  seg->fig.rrect.mode = mode;
  seg->fig.rrect.subid = 1;
  seg->fig.rrect.l_atr = l_atr;
  seg->fig.rrect.l_pat = l_pat;
  seg->fig.rrect.f_pat = f_pat;
  seg->fig.rrect.angle = angle;
  seg->fig.rrect.rh = rh;
  seg->fig.rrect.rv = rv;
  seg->fig.rrect.frame = frame;
  AdjustRect(&seg->fig.rrect.frame);
  
  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ʱߡʱߡ
// ------------------
FSEGMENT* GenOval(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW angle, RECT frame)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_OVAL);

  seg->fig.oval.mode = mode;
  seg->fig.oval.subid = 2;
  seg->fig.oval.l_atr = l_atr;
  seg->fig.oval.l_pat = l_pat;
  seg->fig.oval.f_pat = f_pat;
  seg->fig.oval.angle = angle;
  seg->fig.oval.frame = frame;
  AdjustRect(&seg->fig.oval.frame);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// 
// ------------------
FSEGMENT* GenSec(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW angle, RECT frame, PNT start, PNT end)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_SEC);

  seg->fig.sec.mode = mode;
  seg->fig.sec.subid = 3;
  seg->fig.sec.l_atr = l_atr;
  seg->fig.sec.l_pat = l_pat;
  seg->fig.sec.f_pat = f_pat;
  seg->fig.sec.angle = angle;
  seg->fig.sec.frame = frame;
  AdjustRect(&seg->fig.sec.frame);
  seg->fig.sec.start = start;
  seg->fig.sec.end = end;

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ݷ
// ------------------
FSEGMENT* GenChord(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW angle, RECT frame, PNT start, PNT end)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_CHORD);

  seg->fig.chord.mode = mode;
  seg->fig.chord.subid = 4;
  seg->fig.chord.l_atr = l_atr;
  seg->fig.chord.l_pat = l_pat;
  seg->fig.chord.f_pat = f_pat;
  seg->fig.chord.angle = angle;
  seg->fig.chord.frame = frame;
  AdjustRect(&seg->fig.chord.frame);
  seg->fig.chord.start = start;
  seg->fig.chord.end = end;

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ¿ѷ
// ------------------
FSEGMENT* GenPolygon(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, UW round, UW np, PNT* pt)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_POLYGON)+(sizeof(PNT) * (np-1));

  seg->fig.polygon.mode = mode;
  seg->fig.polygon.subid = 5;
  seg->fig.polygon.l_atr = l_atr;
  seg->fig.polygon.l_pat = l_pat;
  seg->fig.polygon.f_pat = f_pat;
  seg->fig.polygon.round = round;
  seg->fig.polygon.np = np;
  
  memcpy(&seg->fig.polygon.pt[0], pt, sizeof(PNT) * np);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ľ
// ------------------
FSEGMENT* GenLine(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, PNT start, PNT end)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_LINE);

  seg->fig.line.mode = mode;
  seg->fig.line.subid = 6;
  seg->fig.line.l_atr = l_atr;
  seg->fig.line.l_pat = l_pat;
  seg->fig.line.start = start;
  seg->fig.line.end = end;

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ʱ߸̡ʱ߸̡
// ------------------
FSEGMENT* GenArc(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW angle, RECT frame, PNT start, PNT end)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_ARC);

  seg->fig.arc.mode = mode;
  seg->fig.arc.subid = 7;
  seg->fig.arc.l_atr = l_atr;
  seg->fig.arc.l_pat = l_pat;
  seg->fig.arc.angle = angle;
  seg->fig.arc.frame = frame;
  AdjustRect(&seg->fig.arc.frame);
  seg->fig.arc.start = start;
  seg->fig.arc.end = end;

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ޤ
// ------------------
FSEGMENT* GenPolyline(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW round, UW np, PNT* pt)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_POLYLINE)+(sizeof(PNT) * (np-1));

  seg->fig.polyline.mode = mode;
  seg->fig.polyline.subid = 8;
  seg->fig.polyline.l_atr = l_atr;
  seg->fig.polyline.l_pat = l_pat;
  seg->fig.polyline.round = round;
  seg->fig.polyline.np = np;

  memcpy(&seg->fig.polyline.pt[0], pt, sizeof(PNT) * np);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// 
// ------------------
FSEGMENT* GenSpline(FSEGMENT* seg, B mode, UW l_atr, UW l_pat, UW f_pat, W type, UW np, PNT* pt)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_SPLINE)+(sizeof(PNT) * (np-1));

  seg->fig.spline.mode = mode;
  seg->fig.spline.subid = 9;
  seg->fig.spline.l_atr = l_atr;
  seg->fig.spline.l_pat = l_pat;
  seg->fig.spline.f_pat = f_pat;
  seg->fig.spline.type = type;
  seg->fig.spline.np = np;

  memcpy(&seg->fig.spline.pt[0], pt, sizeof(PNT) * np);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ޡ
// ------------------
FSEGMENT* GenMarker(FSEGMENT* seg, B mode, UW marker, UW np, PNT* pt)
{
  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_MARKER)+(sizeof(PNT) * (np-1));

  seg->fig.marker.mode = mode;
  seg->fig.marker.subid = 10;
  seg->fig.marker.marker = marker;
  seg->fig.marker.np = np;

  memcpy(&seg->fig.marker.pt[0], pt, sizeof(PNT) * np);

  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// Ǥտ޷
// ------------------
// uncommented below lines since they are not in use.
#if 0
FSEGMENT* GenScan(FSEGMENT* seg, B mode, UW f_pat, GSCAN* gscan)
     // GSPTR -> TF_SCAN* 
{
  UH* ptr;
  W i;

  seg->tad.id = TC_ESC | TS_FPRIM;
  seg->tad.len = sizeof(TF_SCAN);

  seg->fig.scan.mode = mode;
  seg->fig.scan.subid = 11;
  seg->fig.scan.sy = gscan->sy;
  seg->fig.scan.nr = gscan->nr;
  seg->fig.scan.bx = gscan->bx;

  ptr = (UH*)(seg + sizeof(TADSEG) + sizeof(TF_SCAN));
  for (i = 0; i < gscan->nr; ++i) {
    W nh, j;
    RSPTR rs;

    rs = gscan->rs[i];
    *ptr++ = nh = rs->nh;
    seg->tad.len += (nh + 1) * 2;
    for (j = 0; j < nh; ++nh) {
      *ptr++ = rs->h[j];
    }
  }
  return (FSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}
#endif

// =========================================
// ǡ
// =========================================
// ------------------
// 顼ޥå
// ------------------
DSEGMENT* GenDefColmap(DSEGMENT* seg, UH nent, COLOR* col)
{
  seg->tad.id = TC_ESC | TS_FDEF;
  seg->tad.len = sizeof(TF_COLMAP)+(sizeof(COLOR) * (nent-1));

  seg->def.cmap.unused = 0;
  seg->def.cmap.subid = 0;
  seg->def.cmap.nent = nent;

  memcpy(&seg->def.cmap.col[0], col, sizeof(COLOR) * nent);

  return (DSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ޥǡ
// ------------------
DSEGMENT* GenDefMask(DSEGMENT* seg, UB type, UH id, UH hsize, UH vsize, B* mask)
{
  seg->tad.id = TC_ESC | TS_FDEF;
  seg->tad.len = sizeof(TF_MASK)+((hsize+15)/16*2*vsize) - 2;

  seg->def.mask.type = type; // Ǥϣ˸ꡩ
  seg->def.mask.subid = 1;
  seg->def.mask.id = id;
  seg->def.mask.hsize = hsize;
  seg->def.mask.vsize = vsize;

  memcpy(&seg->def.mask.mask[0], mask, (hsize+15)/16*2*vsize);
  
  return (DSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ѥ
// ------------------
DSEGMENT* GenDefPattern(DSEGMENT* seg, UB type, UH id, UH hsize, UH vsize, UH ncol, COLOR* fgcol, COLOR* bgcol, UH* mask)
{
  B* pos;

  seg->tad.id = TC_ESC | TS_FDEF;
#if 0
  seg->tad.len = sizeof(TF_PATTERN) + 
    (sizeof(COLOR)*ncol) +
    (sizeof(UH)*ncol);
#endif
  seg->tad.len = sizeof(H)*5 + sizeof(COLOR)*(ncol+1) + sizeof(UH)*ncol;

  seg->def.pat.type = type; // Ǥϣ˸ꡩ
  seg->def.pat.subid = 2;
  seg->def.pat.id = id;
  seg->def.pat.hsize = hsize;
  seg->def.pat.vsize = vsize;
  seg->def.pat.ncol = ncol;

  pos = ((B*)&(seg->def.pat)) + sizeof(H)*5;
  memcpy(pos, fgcol, sizeof(COLOR)*ncol);
  pos += sizeof(COLOR)*ncol;
  memcpy(pos, bgcol, sizeof(COLOR));
  pos += sizeof(COLOR);
  memcpy(pos, mask, sizeof(UH)*ncol);

#if 0
  memcpy(&seg->def.pat.fgcol[0]    , fgcol, sizeof(COLOR)*ncol);
  memcpy(&seg->def.pat.fgcol[ncol] , bgcol, sizeof(COLOR)     );
  memcpy(&seg->def.pat.fgcol[ncol+1],mask , sizeof(UH)*ncol);
#endif  

  return (DSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// 
// ------------------
DSEGMENT* GenDefLkind(DSEGMENT* seg, UB type, UH id, UH nb, B** mask)
{
  seg->tad.id = TC_ESC | TS_FDEF;
  seg->tad.len = sizeof(TF_LKIND) + nb - 2;

  seg->def.lkind.type = type;
  seg->def.lkind.subid = 3;
  seg->def.lkind.id = id;
  seg->def.lkind.nb = nb;

  memcpy(&seg->def.lkind.mask[0], mask, nb-2); // ??????

  return (DSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// ޡ
// ------------------
DSEGMENT* GenDefMark(DSEGMENT* seg, UB type, UH id, UH size, COLOR fgcol, UH mask)
{
  seg->tad.id = TC_ESC | TS_FDEF;
  seg->tad.len = sizeof(TF_MARKPAT);

  seg->def.mark.type = type;
  seg->def.mark.subid = 4;
  seg->def.mark.id = id;
  seg->def.mark.size = size;
  toXCOLOR(&seg->def.mark.fgcol, fgcol);
  seg->def.mark.mask = mask;

  return (DSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// =========================================
// 롼
// =========================================
// ------------------
// 롼׳
// ------------------
GSEGMENT* GenGroupStart(GSEGMENT* seg, UH id)
{
  //WPTR ptr;
  //WORD i;

  seg->tad.id = TC_ESC | TS_FGRP;
  seg->tad.len = sizeof(TF_GROUPS);

  seg->grp.start.subid = 0;
  seg->grp.start.unused = 0;
  seg->grp.start.id = id;
  return (GSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

// ------------------
// 롼׽λ
// ------------------
GSEGMENT* GenGroupEnd(GSEGMENT* seg)
{
  //WPTR ptr;
  //WORD i;

  seg->tad.id = TC_ESC | TS_FGRP;
  seg->tad.len = sizeof(TF_GROUPE);

  seg->grp.start.subid = 1;
  seg->grp.start.unused = 0;
  return (GSEGMENT*)((B*)seg + sizeof(TADSEG) + seg->tad.len);
}

