// list.c

// CAUTION !!!
// line 363 Υ㥹Ȥ

#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <bstring.h>

#include "graph.h"
#include "grapherr.h"
#include "debug.h"

// -----ؿ-----

// ꤵ줿ǡʣ
W dup_mem(B* src, W len, B** ptr)
{
    *ptr = (B*)malloc(len);
    if (*ptr == 0) {
        return -1;
    }
    memcpy(*ptr, src, len);
    return 0;
}

// ꥹȹܤ
static W delete_item(ITEM* item)
{
  W rtn = 0;

  // ˤĤʤƤܤϺԲ
  if (item->next != NULL || item->prev != NULL) {
    ERROR(EA_PAR, "delete_item[2]");
    return EA_PAR;
  }
  // ʣǺβ
  if (item->dt != NULL) {
    free(item->dt);
  }
  // ꥹȹܤβ
  free(item);
  return rtn;
}

// ꤵ줿ֹΥꥹȹܤΥɥ쥹
static W get_item(LIST* list, UW idx, ITEM** ptr)
{
  W rtn, i;
  ITEM *item;

  *ptr = NULL;

  if (idx < 0 || idx >= list->cnt) {
    ERROR(EA_PAR, "get_item[1]");
    return EA_PAR;
  }

  item = list->head;
  for (i = 1; i <= idx; ++i) {
    item = item->next;
  }
  *ptr = item;
  return 0;
}

// ꤵ줿ֹΥꥹȹܤڤ
static W cut_item(LIST* list, UW idx, ITEM** ptr)
{
  W rtn;
  ITEM *item, *next, *prev;

  *ptr = NULL;

  if ((rtn = get_item(list, idx, &item)) < 0) {
    ERROR(rtn, "cut_item[1]");
    return rtn;
  }
  prev = item->prev;
  next = item->next;

  prev->next = next;
  next->prev = prev;
  item->next = NULL;
  item->prev = NULL;
  --list->cnt;

  *ptr = item;
  return 0;
}

// ꥹȹܤΣɣĤֵѤ
static W create_item(W id, W len, B* dt, ITEM** ptr)
{
  W rtn = 0;
  ITEM *item = NULL;

  *ptr = NULL;

  // ͭΰƤꤹ
  item = (ITEM*)malloc(sizeof(ITEM));
  if (item == 0) {
      return -1;
  }

  item->next = NULL; // ΣѣգŤؤΥݥ
  item->prev = NULL; // ΣѣգŤؤΥݥ
  item->id = id;     // ǡɣ
  item->len = len;   // ǡΥХȥ

  // ƥ֥å˥ǡʣ
  if ((rtn = dup_mem(dt, len, &item->dt)) < 0) {
    ERROR(rtn, "create_item[3]");
    goto err_exit;
  }
  // ｪλΥֵ
  *ptr = item;
  return rtn;

 err_exit:
  // ۾ｪλ顼ɤֵ
  if (item != NULL) free(item);
  return rtn;
}

// ꤵ줿ֹΥꥹȹܤľ˥ꥹȹܤ
static W insert_item(LIST* list, ITEM* item, W idx)
{
  W rtn, i;
  ITEM *next, *prev;

  if (idx < 0) {
    // ֤ξϥꥹȤκǸϿ
    if ((next = list->head) != NULL) {
      // ¾Υȥ꡼
      prev = next->prev;

      item->next = next;
      item->prev = prev;
      prev->next = item;
      next->prev = item;
    }
    else{
      // ¾Υȥ꡼ʤ
      list->head = item;
      item->next = item;
      item->prev = item;
    }
  }
  else if (idx >= list->cnt) {
    ERROR(EA_PAR, "insert_item[1]");
    return EA_PAR;
  }
  else {
    next = list->head;
    for (i = 1; i <= idx; ++i) {
      next = next->next;
    }
    prev = next->prev;
    
    item->next = next;
    item->prev = prev;
    prev->next = item;
    next->prev = item;
  }
  ++list->cnt;

  return 0;
}

// ꥹ֥åΣɣĤֵѤ
LIST* cre_lst()
{
  LIST *list;

  // ͭΰƤꤹ
  list = (LIST*)malloc(sizeof(LIST));
  if (list == 0) {
    ERROR(0, "cre_lst[1]");
    return 0;
  }
  list->cnt = 0;
  list->head = NULL;

  // ｪλΥֵ
  return list;
}

// ꥹ֥å
void del_lst(LIST* list)
{
  ITEM *item;

  // ͭΥɥ쥹
  // ٤ƤΥꥹȹܤ
  while(list->cnt > 0) {
    cut_item(list, 0, &item);
    delete_item(item);
  }
  // ꥹ֥åβ
  free(list);
}

// ꥹȹܤ
void del_lsti(LIST* list, W idx)
{
  ITEM *item;

  if (cut_item(list, idx, &item) < 0) {
    ERROR(0, "del_lsti[2]");
  }
  delete_item(item);
}

// ꤵ줿ֹΥꥹȹܤľ˥ꥹȹܤ
W ins_lsti(LIST* list, W idx, W id, W len, B* dt)
{
  W rtn = 0;
  ITEM *item;

  // ꥹȹܤ
  if((rtn = create_item(id, len, dt, &item)) < 0) {
    ERROR(rtn, "ins_lsti[2]");
    return rtn;
  }
  if((rtn = insert_item(list, item, idx)) < 0) {
    ERROR(rtn, "ins_lsti[3]");
    delete_item(item);
    return rtn;
  }
  return 0;
}

// ꤵ줿ֹΥꥹȹܤΥɥ쥹
W get_lsti(LIST* list, UW idx, ITEM** ptr)
{
  *ptr = NULL;

  // ꥹ֥åʶͭˤΥɥ쥹
  return get_item(list, idx, ptr);
}

// ꤵ줿ꥹˤꥹȹܤο
W lst_cnt(LIST* list)
{
  // ꥹ֥åʶͭˤΥɥ쥹
  return list->cnt;
}

// ꤵ줿ֹΥꥹȹܤڤ
W cut_lsti(LIST* list, UW idx, ITEM** ptr)
{
  *ptr = NULL;

  return cut_item(list, idx, ptr);
}

// ꤵ줿ꥹΥꥹȹܤ򸡺
W ser_lst(LIST* list, TC* str, TC** ptr)
{
  W i, len;
  ITEM *item, *next, *prev;

  *ptr = NULL;

  // ꥹ֥åʶͭˤΥɥ쥹
  len = tc_strlen(str);
  item = list->head;

  for (i = 0; i < list->cnt; ++i) {
    if (tc_strncmp(str, item->dt, len) == 0) {
      *ptr = (TC*)item->dt;
      return 0;
    }
    item = item->next;
  }
  return EA_UNDEF;
}

