#include <btron/taddata.h>

#define SEG_NOUSE 0x0000
#define SEG_CTRL  0x0001
#define SEG_CHAR  0x0002
#define SEG_LANG  0x0003
#define SEG_SPEC  0x0004
#define SEG_ESC   0x0005
#define SEG_EOF   0x0006

#define TC_MASK   0xff00
#define TC_EOF    0xfffe
#define TC_END    0xffff

typedef union _SEGHEAD {
  TADSEG s;
  LTADSEG l;
} SEGHEAD;

// ======================
// | ޷ǥ |
// ======================
typedef union _FIG {
  TF_RECT rect;         //  0: Ĺ
  TF_RRECT rrect;       //  1: ѴĹ
  TF_OVAL oval;         //  2: ʱߡʱߡ
  TF_SEC sec;           //  3: 
  TF_CHORD chord;       //  4: ݷ
  TF_POLYGON polygon;   //  5: ¿ѷ
  TF_LINE line;         //  6: ľ
  TF_ARC arc;           //  7: ʱ߸̡ʱ߸̡
  TF_POLYLINE polyline; //  8: ޤ
  TF_SPLINE spline;     //  9: 
  TF_MARKER marker;     // 10: ޡ
  TF_SCAN scan;         // 11: Ǥտ޷
} FIG;

typedef struct	{
  TADSEG tad;
  FIG fig;
} FSEGMENT;

// ==================
// |  |
// ==================
typedef struct	{
  TADSEG tad;
  IMAGESEG image;
} ISEGMENT;

// ========================
// | ǡ |
// ========================
typedef union _DATADEF {
  TF_COLMAP cmap;
  TF_MASK mask;
  TF_PATTERN pat;
  TF_LKIND lkind;
  TF_MARKPAT mark;
} DEF;

typedef struct	{
  TADSEG tad;
  DEF def;
} DSEGMENT;

// ==========================
// | 롼 |
// ==========================
typedef union _GROUP {
  TF_GROUPS start;
  TF_GROUPE end;
} GRP;

typedef struct {
  TADSEG tad;
  GRP grp;
} GSEGMENT;

#ifndef _GEN_FIG

// gen_fig.c
B* GenRect();
B* GenRrect();
B* GenOval();
B* GenSec();
B* GenChord();
B* GenPolygon();
B* GenLine();
B* GenArc();
B* GenPolyline();
B* GenSpline();
B* GenMarker();
B* GenScan();
B* GenDefColmap();
B* GenDefMask();
B* GenDefPattern();
B* GenDefLkind();
B* GenDefMark();
B* GenGroupStart();
B* GenGroupEnd();

// maskpat.c
B* CreatePattern();

#endif


#ifndef _TAD_LIB

// tad.c
H* NextSegment();
UW SegmentLen();
UH TadNum();
UW TadLen();
B* TadCpy();
B* TadCat();

#endif

// moved from fileio.h
#ifndef _DEFINE_STRUCT_FILE
#define _DEFINE_STRUCT_FILE

typedef struct {
  W flag;
  W vid;
  LINK link;
  W fd;
  W openmode;
  W error;
  UH subtype;
  W rectype;
  W recsize;
  W offset;
  B* buff;
  // added
  W first; 
} FILE;

#endif

#ifndef EOF
#define EOF 0
#endif

