// tad.c

#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <bstring.h>

#define _TAD_LIB
#include "segment.h"
#include "debug.h"

//
//  ԣ饤֥
//-----------------------------------------------------------------------
//  ԣ
//  ԣȤϡԣĻͤ˽򤷤ȤʣϢ³Ƥǡ
//ꡤüȤ0xFFFF֤Ƥ롥
//ʸɤϣʸǣȤȤư롥
//

TC SegmentType(TC tc)
     // WORD -> TC
{
  if ( tc            == TC_EOF ) return SEG_EOF;
  if ((tc & TC_MASK) == 0      ) return SEG_CTRL;
  if ((tc & TC_MASK) == TC_LANG) return SEG_LANG;
  if ((tc & TC_ESC ) == TC_ESC ) return SEG_ESC;
  if ((tc & TC_MASK) == TC_SPEC) return SEG_SPEC;
  return SEG_CHAR;
}

TC* NextSegment(TC* tad)
{
  TC tc;
  W len;

  tc = *tad;
  if (tc == TC_NULL) {
    // üξϸֵ֤߰
    return tad;
  }

  tad++;
  if (SegmentType(tc) != SEG_ESC) {
    // Хȥɤξ
    return tad;
  }
  len = *tad++;
  if (len == 0xffff) {
    // 顼Ȥξ
    return NULL;
  }
  return (TC*)((B*)tad + len);
}

UW SegmentLen(TC* tad)
{
  TC tc;
  W len;

  tc = *tad;
  if (tc == TC_NULL) {
    // üξ
    return 0L;
  }

  tad++;
  if (SegmentType(tc) != SEG_ESC) {
    // ʸɤξ
    return sizeof(TC);
  }

  len = *tad++;
  if (len == 0xffff) {
    // 顼Ȥξ
    return (UW)(*(W*)tad + sizeof(LTADSEG));
  }
  return (UW)(len+sizeof(TADSEG));
}

UW TadNum(B* tad)
{
  UW num = 0;
  UW len;

  for (;;) {
    if ((len = SegmentLen((TC*)tad)) == 0L)
      break;
    num++;
    tad += len;
  }
  return num;
}

UW TadLen(B* tad)
{
  UW tlen = 0L;
  UW len;

  for (;;) {
    if ((len = SegmentLen((TC*)tad)) == 0L)
      break;
    tlen += len;
    tad += len;
  }
  return tlen;
}

// B*ؤ֤ͥ㥹ȡġ
B* TadCpy(B* dst, B* src)
{
  return (B*)memcpy(dst, src, TadLen(src) + 2);
}

B* TadCat(B* dst, B* src)
{
  return (B*)memcpy(dst + TadLen(dst), src, TadLen(src) + 2);
}

W push_tray(RECT rect, B* seg, W type)
{
  TRAYREC trayrec[2];
  FIGSEG  figseg;
  W    sts;
  RECT frec;

  frec = rect;
  frec.c.right += 1;
  frec.c.bottom += 1;
  // 쥳ɡʿ޷ϥȡ
  figseg.view   = frec;
  figseg.draw   = frec;
  figseg.h_unit = 0xff88;
  figseg.v_unit = 0xff88;
  figseg.ratio  = 0L;

  trayrec[0].id  = TS_FIG;
  trayrec[0].len = sizeof(FIGSEG);
  trayrec[0].dt  = (B*)&figseg;

  // 쥳ɡʿ޷쥳ɡ
  trayrec[1].id  = TR_FIG;
  trayrec[1].len = TadLen(seg);
  trayrec[1].dt  = seg;

  if (type == 0) {
    // ???
    if ((sts = tpsh_dat(trayrec, 2, NULL)) < 0) {
      ERROR(sts, "push_tray[1]");
    }
  }
  else {
    // ȥ졼
    if ((sts = tset_dat(trayrec, 2)) < 0) {
      ERROR(sts, "push_tray[2]");
    }
  }
  return sts;
}

