// tbl.c
#include <basic.h>
#include <btron/btron.h>
#include <btron/hmi.h>
#include <bmath.h>

#include "grapherr.h"
#include "debug.h"
#include "graph.h"

// ------------------------------------------
// ơ֥ΰκ
// ------------------------------------------
TABLE* cre_tbl(UW row, UW column, UW size)
{
  UW tsize;
  W sts;
  TABLE* tbl = 0;

  // ENTRY("cre_tbl()");

  // ɬפʥ̤η׻å
  tsize = (row * column * size) + sizeof(TABLE);

  // Хγ
  if ((tbl = (TABLE*)calloc(1, tsize)) == 0) {
    // ꤬Ǥʤä
    return 0;
  }
  // Ͽ
  tbl->row = row;
  tbl->column = column;
  tbl->size = size;
  tbl->offset = sizeof(TABLE);

  // ϥɥơ֥ϥɥȤֵ
  // EXIT("cre_tbl()");

  return tbl;
}

// ------------------------------------------
// ꤵ줿ơ֥ƱΥơ֥ΰκ
// ------------------------------------------
TABLE* cre_ctb(TABLE* hMem, UW size)
{
  TABLE* tbl = 0;

  // ENTRY("cre_ctb()");

  // ХΥݥ󥿤
  // Ʊ礭Υơ֥
  if (size == 0) size = hMem->size;
  if ((tbl = cre_tbl(hMem->row, hMem->column, size)) == 0) {
    ERROR(-1, "cre_ctb[2]");
  }
  //  EXIT("cre_ctb()");

  return tbl;
}

// ------------------------------------------
// ơ֥ΰβ
// ------------------------------------------
void del_tbl(TABLE *tbl, BOOL opt)
{
  W sts;
  UW i, t;
  B* dp;

  // ENTRY("del_tbl()");

  // ХΥݥ󥿤

  if (opt) {
    t = tbl->row * tbl->column;
    //dp = (B**)(((B*)tbl) + tbl->offset);
    dp = ((B*)tbl) + tbl->offset;

    for (i=0; i<t; ++i, (dp += tbl->size)) {
      if (*((void**)dp) != NULL) {
        free(*((void**)dp));
      }
    }
  }
  free(tbl);
  // EXIT("del_tbl()");
}

// ------------------------------------------
// ơ֥ΥեޥåȤ
// ------------------------------------------
W get_tbf(TABLE* tbl, W* row, W* column)
{
  // ENTRY("get_tbf()");

  // ХΥݥ󥿤
  // Կֵ
  *row = tbl->row;
  *column = tbl->column;

  // ｪλ
  // EXIT("get_tbf()");

  return 0;
}

// ------------------------------------------
// ơ֥Υǡʣ
// ------------------------------------------
W cpy_tbl(TABLE* tbl1, TABLE* tbl2)
{
  W sts;

  // ENTRY("cpy_tbl()");

  // ХΥݥ󥿤
  // ѥ᥿θ
  if (tbl1->row != tbl2->row || tbl1->column != tbl2->column ||
      tbl1->size != tbl2->size) {
    ERROR(EA_HTBL, "cpy_tbl[3]");
    return EA_HTBL;
  }
  // ǡž
  memcpy((B*)tbl1 + tbl1->offset,
           (B*)tbl2 + tbl2->offset,
           tbl1->row * tbl1->column * tbl1->size);

  // ｪλ
  // EXIT("cpy_tbl()");

  return 0;
}

// ------------------------------------------
// ơ֥ʣ
// ------------------------------------------
TABLE* dup_tbl(TABLE* hOrg)
{
  TABLE* hDup;
  W sts;

  // ENTRY("dup_tbl()");

  // Ʊ礭Υơ֥
  if ((hDup = cre_ctb(hOrg, 0)) == 0) {
    ERROR(hDup, "dup_tbl[1]");
    return 0;
  }
  // ơ֥Ƥʣ
  if ((sts = cpy_tbl(hDup, hOrg)) < 0) {
    ERROR(sts, "dup_tbl[2]");
    del_tbl(hDup, FALSE); // added
    return 0;
  }
  // ｪλ
  // EXIT("dup_tbl()");

  return hDup;
}

// ------------------------------------------
// ơ֥ΥǡΥɥ쥹
// ------------------------------------------
B* get_adr(TABLE* tbl, UW row, UW column)
{
  return (B*)tbl + (tbl->offset + (((row * tbl->column)+column) * tbl->size));
}

// ------------------------------------------
// ơ֥ΰΥǡ
// ------------------------------------------
W get_tbl(TABLE* tbl, UW row, UW column, B* ptr)
{
  UW wk;
  W sts;
  B* dp;

  // ENTRY("get_tbl()");

  // ѥ᥿θ
  if (tbl->row <= row || tbl->column <= column) {
    ERROR(EA_PAR, "get_tbl[2]");
    return EA_PAR;
  }
  // ǡ֤
  dp = get_adr(tbl, row, column);

  // ǡž
  memcpy(ptr, dp, tbl->size);

  // ｪλ
  // EXIT("get_tbl()");

  return 0;
}

// ------------------------------------------
// ơ֥ΰΥǡѹ
// ------------------------------------------
W set_tbl(TABLE* tbl, UW row, UW column, B* ptr)
{
  UW wk;
  W sts;
  B* dp;

  // ENTRY("set_tbl()");

  // ѥ᥿θ
  if (tbl->row <= row || tbl->column <= column) {
    ERROR(EA_PAR, "set_tbl[2]");
    return EA_PAR;
  }
  // ǡ֤
  dp = get_adr(tbl, row, column);

  // ǡž
  memcpy(dp, ptr, tbl->size);

  // ｪλ
  // EXIT("set_tbl()");

  return 0;
}

// ------------------------------------------
// DOUBLEINTѴΨǴ
// ------------------------------------------
//
//ͣͣϰϤ˴ޤޤ¿֣ͣ
//  ͣͣϰϤͤѴ
//
W dtoi(double dVal, double dMax, double dMin, W iMax, W iMin)
{
  double dRange;
  UW iRange, lWk;
  W iWk;

  // ͥå
  if (dVal >= dMax) return iMax;

  // Ǿͥå
  if (dVal < dMin)  return iMin;

  dRange = dMax - dMin;
  iRange = iMax - iMin;

  lWk = ((dVal-dMin) * 1000.0) / dRange;
  iWk = (lWk  * iRange) / 1000;

  return iWk + iMin;
}

// ------------------------------------------
// ơ֥ΰΥǡѴDOUBLEINTѴ
// ------------------------------------------
W d2i_tbl(TABLE* tbl1, TABLE *tbl2, double dMax, double dMin, W iMax, W iMin)
{
  B *dp1, *dp2;
  UW i, t;
  W sts;

  // ENTRY("d2i_tbl()");

  // ѥ᥿θ
  if (tbl1->row != tbl2->row || tbl1->column != tbl2->column) {
    ERROR(EA_PAR, "d2i_tbl[3]");
    return EA_PAR;
  }

  t = tbl1->row * tbl1->column;
  dp1 = (B*)tbl1 + tbl1->offset;
  dp2 = (B*)tbl2 + tbl2->offset;

  for (i=0; i<t; ++i) {
    *((W*)dp1) = dtoi(*((DOUBLE*)dp2), dMax, dMin, iMax, iMin);
    dp1 += tbl1->size;
    dp2 += tbl2->size;
  }

  // ｪλ
  // EXIT("d2i_tbl()");

  return 0;
}

// ------------------------------------------
// ơ֥ΰΥǡѴʸDOUBLEѴ
// ------------------------------------------
W s2d_tbl(TABLE* tbl1, TABLE* tbl2, double dMax, double dMin, W iMax, W iMin)
{
  DOUBLE *dp1, dval;
  TC **dp2, *tp;
  UW i, t;
  W sts;

  // ENTRY("s2d_tbl()");

  // ѥ᥿θ
  if (tbl1->row != tbl2->row || tbl1->column != tbl2->column) {
    ERROR(EA_PAR, "s2d_tbl[3]");
    return EA_PAR;
  }
  t = tbl1->row * tbl1->column;
  dp1 = (DOUBLE*)((B*)tbl1 + tbl1->offset);
  dp2 = (TC**)((B*)tbl2 + tbl2->offset);

  for (i=0; i<t; ++i, dp1++, dp2++) {
    if ((tp = *dp2) != NULL) {
      dval = tc_strtod(tp, NULL);
      *dp1 = dval;
    }
    else {
      *dp1 = 0.0;
    }
  }

  // ｪλ
  // EXIT("s2d_tbl()");

  return 0;
}

